//#include <stdlib.h>
//#include <stdio.h>
#include <iostream>
using namespace std;

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>
#include <SDL/SDL_ttf.h>
#include "constantes.hpp"
#include "jeu.hpp"
/*#include "editeur.h"*/

long score;

//int main(int argc, char *argv[])
int main(void)
{
    SDL_Surface *ecran = NULL, *menu = NULL, *texte_niveau, *txt_score,*txt_nbvie;
    SDL_Rect positionMenu,Pos_txtNiveau,Pos_txtScore;
    SDL_Event event;
 
    int continuer_main=1;
    int nb_niveaux=5;
    long numero_niveau=1;
    //objet gérant les propriétés de la partie
    struct Partie prop_partie;
    prop_partie.score=0;
    prop_partie.nbVie=5;

    char s[30]; //chaine de caractère pour afficher numero de niveau
  //initialise SDL audi, video, timer, traite les erreurs.

if (SDL_Init(SDL_INIT_VIDEO| SDL_INIT_TIMER |SDL_INIT_AUDIO)==-1)
{
	//error initializing SDL
	//report the error
	fprintf(stderr,SDL_GetError());
	//end the program
	exit(1);
}


///--------------Musique--------------

    /* On ouvre un périphérique audio */

if(Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 1024)==-1)
{
	printf("Mix_OpenAudio: %s\n", Mix_GetError());
	exit(2);
}
Mix_Chunk *clic_menu;
clic_menu = Mix_LoadWAV("son/clic_menu.ogg");
Mix_Music *musique_menu;
musique_menu = Mix_LoadMUS("son/menu1.ogg");

if(musique_menu == NULL)
{
	printf("Impossible de charger le fichier son %s\n", Mix_GetError());
	return 1;
}
if(Mix_PlayMusic(musique_menu, 0) == -1)
{
	printf("Impossible de jouer le son: %s\n", Mix_GetError());
	return 1;
}

///Icone fenêtre SDL

    SDL_WM_SetIcon(IMG_Load("images/skull_32x32.png"), NULL); // L'icone doit etre chargé avant SDL_SetVideoMode

    ecran = SDL_SetVideoMode(LARGEUR_FENETRE, HAUTEUR_FENETRE, 32, SDL_HWSURFACE | SDL_DOUBLEBUF);
    //test d'erreur allocation ecran
    if (ecran == NULL)
    {
  	    fprintf(stderr,"Impossible d'initialiser l'écran\n");
	    exit(1);
    }
 

    SDL_WM_SetCaption("Lorann SDL", NULL);

///---------gestion du texte -------------------------------


//initialiser TTF-------------------------
if( TTF_Init() == -1 )
    {
        printf("erreur TTF");
    }

TTF_Font *font=NULL;
//Fixer couleur (r,g,b,inutilisé)
SDL_Color textColor={255, 210, 55, 0};
//Ouverture de la police en taille 12
font = TTF_OpenFont("images/FreeSans.ttf",12);
if(font==NULL)
                {
                    printf("TTF_OpenFont: %s\n", TTF_GetError());
                    // handle error
                }

//chargement du menu
menu = IMG_Load("images/menu.png");
//et position du menu
positionMenu.x = 200;
positionMenu.y = 130;
///"##"###############BOUCLE PRINCIPALE DU JEU##################
// testons le clavier : 1 : jouer, escape :  quitter
while (continuer_main)
	{
		SDL_WaitEvent(&event);
		switch(event.type)
		{
			case SDL_QUIT:
			continuer_main = 0;
			break;

			case SDL_KEYDOWN:
			switch(event.key.keysym.sym)
			{
				case SDLK_ESCAPE: // Veut arreter le jeu->drapeau de partie = 0
				continuer_main = 0;
				break;
				case SDLK_KP1: // Demande à jouer->coupe la musique
				Mix_HaltMusic();
				Mix_FreeMusic(musique_menu);//et libère la zone mémoire
				//fin de partie : réinit vie et mise mise à zéro score
					if(prop_partie.nbVie==0)
					{
						prop_partie.score=0;
						prop_partie.nbVie=5;
					}
				prop_partie=jouer(ecran,numero_niveau,prop_partie);

				printf("score %ld\n",prop_partie.score);
				break;
				case SDLK_UP:
					if(numero_niveau<nb_niveaux)
					{
						numero_niveau++;
						Mix_PlayChannel(0, clic_menu, 0);
					}
				break;
				case SDLK_DOWN:
					if(numero_niveau>1)
					{
						numero_niveau--;
						Mix_PlayChannel(0, clic_menu, 0);
					}
				break;
				default:
				break;
			}
                break;
        }

       // Effacement de l'ecran en memoire
	SDL_FillRect(ecran, NULL, SDL_MapRGB(ecran->format, 0, 0, 0));
	/// ---------------Affichage du texte de niveau


	sprintf(s, "NIVEAU : 0%ld ", numero_niveau); // conversion de l'entier score  vers un char* (variable 's')


if((texte_niveau=TTF_RenderText_Blended(font,s,textColor))==NULL)
        {
        printf("Erreur TTF_RenderText: %s", TTF_GetError());
        }
else
        {
        texte_niveau = TTF_RenderText_Blended(font, s, textColor );
        }


	Pos_txtNiveau.x=230;
	Pos_txtNiveau.y=206;

	SDL_BlitSurface(texte_niveau, NULL, ecran, &Pos_txtNiveau);

	sprintf(s, " Score : 0%ld", prop_partie.score); // conversion de l'entier score  vers un char* (variable 's')
	txt_score = TTF_RenderText_Blended(font, s, textColor );
	Pos_txtScore.x=330;
	Pos_txtScore.y=206;
	SDL_BlitSurface(txt_score, NULL, ecran, &Pos_txtScore);

	sprintf(s, " Resurrections : 0%d", prop_partie.nbVie); // conversion de l'entier score  vers un char* (variable 's')
	txt_nbvie = TTF_RenderText_Blended(font, s, textColor );
	Pos_txtScore.x=430;
	Pos_txtScore.y=206;
	SDL_BlitSurface(txt_nbvie, NULL, ecran, &Pos_txtScore);


	//placer le menu dans la memoire ecran

       SDL_BlitSurface(menu, NULL, ecran, &positionMenu);
        //AFFICHER
        SDL_Flip(ecran);
    }//fin boucle principale while

//liberer la memoire
SDL_FreeSurface(menu);
/* On libère le matériel son*/
Mix_CloseAudio();
//quitter
SDL_Quit();

return EXIT_SUCCESS;
}


